---
title: font-variant-alternates
slug: Web/CSS/font-variant-alternates
tags:
  - CSS
  - CSS Fonts
  - CSS Property
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>font-variant-alternates</code></strong> CSS property controls the usage of alternate glyphs. These alternate glyphs may be referenced by alternative names defined in {{cssxref("@font-feature-values")}}.</span></p>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
font-variant-alternates: normal;
font-variant-alternates: historical-forms;

/* Functional notation values */
font-variant-alternates: stylistic(user-defined-ident);
font-variant-alternates: styleset(user-defined-ident);
font-variant-alternates: character-variant(user-defined-ident);
font-variant-alternates: swash(user-defined-ident);
font-variant-alternates: ornaments(user-defined-ident);
font-variant-alternates: annotation(user-defined-ident);
font-variant-alternates: swash(ident1) annotation(ident2);

/* Global values */
font-variant-alternates: initial;
font-variant-alternates: inherit;
font-variant-alternates: unset;
</pre>

<p>The {{cssxref("@font-feature-values")}} at-rule can define names for alternative glyph functions (<code>stylistic</code>, <code>styleset</code>, <code>character-variant</code>, <code>swash</code>, <code>ornament</code> or <code>annotation</code>), associating the name with OpenType parameters. This property allows those human-readable names (defined in {{cssxref("@font-feature-values")}}) in the stylesheet.</p>

<h2 id="Syntax">Syntax</h2>

<p>This property may take one of two forms:</p>

<ul>
 <li>either the keyword <code>normal</code></li>
 <li>or one or more of the other keywords and functions listed below, space-separated, in any order.</li>
</ul>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>normal</code></dt>
 <dd>This keyword deactivates alternate glyphs.</dd>
 <dt><code>historical-forms</code></dt>
 <dd>This keyword enables historical forms — glyphs that were common in the past but not today. It corresponds to the OpenType value <code>hist</code>.</dd>
 <dt><code><a name="stylistic()"></a>stylistic()</code></dt>
 <dd>This function enables stylistic alternates for individual characters. The parameter is a font-specific name mapped to a number. It corresponds to the OpenType value <code>salt</code>, like <code>salt 2</code>.</dd>
 <dt><code><a name="styleset()"></a>styleset()</code></dt>
 <dd>This function enables stylistic alternatives for sets of characters. The parameter is a font-specific name mapped to a number. It corresponds to the OpenType value <code>ssXY</code>, like <code>ss02</code>.</dd>
 <dt><code><a name="character-variant()"></a>character-variant()</code></dt>
 <dd>This function enables specific stylistic alternatives for characters. It is similar to <code>styleset()</code>, but doesn't create coherent glyphs for a set of characters; individual characters will have independent and not necessarily coherent styles. The parameter is a font-specific name mapped to a number. It corresponds to the OpenType value <code>cvXY</code>, like <code>cv02</code>.</dd>
 <dt><code><a name="swash()"></a>swash()</code></dt>
 <dd>This function enables <a href="http://en.wikipedia.org/wiki/Swash_%28typography%29">swash</a> glyphs. The parameter is a font-specific name mapped to a number. It corresponds to the OpenType values <code>swsh</code> and <code>cswh</code>, like <code>swsh 2</code> and <code>cswh 2</code>.</dd>
 <dt><code><a name="ornaments()"></a>ornaments()</code></dt>
 <dd>This function enables ornaments, like <a href="http://en.wikipedia.org/wiki/Fleuron_%28typography%29">fleurons</a> and other dingbat glyphs. The parameter is a font-specific name mapped to a number. It corresponds to the OpenType value <code>ornm</code>, like <code>ornm 2</code>.
 <div class="note"><strong>Note:</strong> In order to preserve text semantics, font designers should include ornaments that don't match Unicode dingbat characters as ornamental variants of the bullet character (U+2022). Be aware that some existing fonts don't follow this advice.</div>
 </dd>
 <dt><code><a name="annotation()"></a>annotation()</code></dt>
 <dd>This function enables annotations, like circled digits or inverted characters. The parameter is a font-specific name mapped to a number. It corresponds to the OpenType value <code>nalt</code>, like <code>nalt 2</code>.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;p&gt;Firefox rocks!&lt;/p&gt;
&lt;p class="variant"&gt;Firefox rocks!&lt;/p&gt;
</pre>

<h3 id="CSS"><span class="pun">CSS</span></h3>

<pre class="brush: css notranslate">@font-feature-values "Leitura Display Swashes" {
    @swash { fancy: 1 }
}

p {
  font-size: 1.5rem;
}

.variant {
  font-family: Leitura Display Swashes;
  font-variant-alternates: swash(fancy);
}</pre>

<h3 id="Result">Result</h3>

<div class="note">
<p><strong>Note:</strong> You need to install the OpenType font <em>Leitura Display Swashes</em> for this example to work. You can find a few free versions for testing purposes, for example from <a href="http://fontsgeek.com/fonts/Leitura-Display-Swashes">fontsgeek.com</a>.</p>
</div>

<p>{{ EmbedLiveSample('Examples', '', '', '', 'Web/CSS/font-variant-alternates') }}</p>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any standard.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.font-variant-alternates")}}</p>

<h2 id="See-also">See Also</h2>

<ul>
  <li>{{cssxref("font-variant")}}</li>
  <li>{{cssxref("font-variant-caps")}}</li>
  <li>{{cssxref("font-variant-east-asian")}}</li>
  <li>{{cssxref("font-variant-ligatures")}}</li>
  <li>{{cssxref("font-variant-numeric")}}</li>
 </ul>